<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * 
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */
 
 
require_once(PATH_t3lib.'class.t3lib_install.php');

class tx_ccfeinfo {

	var $prefixCSS = 'tx-ccfeinfo';
	var $prefixId = 'tx_ccfeinfo';

	var $pObj;

	var $types = array (
		'gpvar' => 'GET/POST Vars',
		'user' => 'User',
		'constants' => 'Constants',
		'globjects' => 'Global Objects',
		'locals' => 'Local Variables',
		'globals' => 'Global Variables',
		'tsfe' => 'TSFE (excerpt)',
		'env' => 'Environment',
		'debuginfo' => 'Debug info',
		'phpinfo' => 'PHPInfo',
		);

	var $selected = array();

	function init(&$pObj)	{
		$this->pObj = &$pObj;
		if ($this->pObj->prefixId) {
			$this->prefixId = $this->pObj->prefixId.'_'.$this->prefixId;
		}
	}


	function information($type)	{
		global $TSFE, $HTTP_GET_VARS, $HTTP_POST_VARS;

		$content = '';

		switch(TYPO3_MODE.':'.$type)	{

			
			case 'FE:gpvar':
			case 'BE:gpvar':
				$out = $this->debugvar($HTTP_GET_VARS, $name = 'GET Variables', $level = 2, $recursive = true);
				$content .= $this->section('GET Variables:', $out);
				$out = $this->debugvar($HTTP_POST_VARS, $name = 'POST Variables', $level = 2, $recursive = true);
				$content .= $this->section('POST Variables:', $out);
			break;

			case 'BE:constants':
				$const[]='PATH_'.'typo3: '.PATH_typo3;
				$const[]='PATH_'.'typo3_mod: '.PATH_typo3_mod;	
				
			case 'FE:constants':
				$const[]='TYPO3_'.'OS: '.TYPO3_OS;
				$const[]='TYPO3_'.'MODE: '.TYPO3_MODE;
				$const[]='TYPO3_'.'mainDir: '.TYPO3_mainDir;
				$const[]='PATH_'.'thisScript: '.PATH_thisScript;
				$const[]='PATH_'.'site: '.PATH_site;
				$const[]='PATH_'.'typo3conf: '.PATH_typo3conf;
				$const[]='PATH_'.'tslib: '.PATH_tslib;
				$const[]='PATH_'.'t3lib: '.PATH_t3lib;
				
				$out = implode('<br />',$const);
				$content .= $this->section('Constans:', $out);
			break;


			case 'FE:user':
			case 'BE:user':
				global $BE_USER;

				$user = array();
				if(is_object($TSFE)) {
					$user['fe_user->user']=$TSFE->fe_user->user;
					$user['fe_user->groupData']=$TSFE->fe_user->groupData;
				}
				if(is_object($BE_USER)) {
					$user['BE_USER->user']=$BE_USER->user;
					$user['BE_USER->groupData']=$BE_USER->groupData;
				}
				$out = $this->debugvar($user, $name = 'User', $level = 2, $recursive = true);
				$content .= $this->section('User:', $out);
			break;
			
			case 'FE:tsfe':

				$tsfe = array();
				$tsfe['id']=$TSFE->id;
				$tsfe['type']=$TSFE->type;
				$tsfe['no_cache']=$TSFE->no_cache;
				$tsfe['no_cache']=$TSFE->no_cache;
				$tsfe['page']=$TSFE->page;
				$tsfe['fe_user->user']=$TSFE->fe_user->user;
				$tsfe['fe_user->groupData']=$TSFE->fe_user->groupData;
				$tsfe['fe_user:gr_list']=$TSFE->gr_list;

				$out = $this->debugvar($tsfe, $name = 'TSFE (excerpt)', $level = 2, $recursive = true);
				$content .= $this->section('TSFE (excerpt):', $out);
			break;


			case 'FE:locals':
			case 'BE:locals':
				global $SOBE;
				
				if (is_object($this->pObj)) {
					$objArray = array();
					while(list($objName,$obj)=each($this->pObj))	{
						if(!is_object($obj)){
							$objArray['$this->'.$objName] = $obj;
						}
					}
					$out = $this->debugvar($objArray, $name = 'Local Variables', $level = 2, $recursive = true);
					$content .= $this->section('Local Variables', $out);
				}
			break;
			
			case 'FE:globals':
			case 'BE:globals':
				$objArray = array();
				while(list($objName,$obj)=each($GLOBALS))	{
					if(!is_object($obj)){
						$objArray['$'.$objName] = $obj;
					}
				}
				$out = $this->debugvar($objArray, $name = 'Global Variables', $level = 1, $recursive = true);
				$content .= $this->section('Global Variables:', $out);
			break;
			

			case 'FE:env':
			case 'BE:env':

				$getEnvArray = array();
				$gE_keys = explode(',','QUERY_STRING,HTTP_ACCEPT,HTTP_ACCEPT_ENCODING,HTTP_ACCEPT_LANGUAGE,HTTP_CONNECTION,HTTP_COOKIE,HTTP_HOST,HTTP_USER_AGENT,REMOTE_ADDR,REMOTE_HOST,REMOTE_PORT,SERVER_ADDR,SERVER_ADMIN,SERVER_NAME,SERVER_PORT,SERVER_SIGNATURE,SERVER_SOFTWARE,GATEWAY_INTERFACE,SERVER_PROTOCOL,REQUEST_METHOD,SCRIPT_NAME,PATH_TRANSLATED,HTTP_REFERER,PATH_INFO');
				while(list(,$k)=each($gE_keys))	{
					$getEnvArray[$k] = getenv($k);
				}

				$out = $this->debugvar(t3lib_div::getIndpEnv('_ARRAY'), $name = 't3lib_div::getIndpEnv()', $level = 2, $recursive = true);
				$content .= $this->section('t3lib_div::getIndpEnv():', $out);

				$out = $this->debugvar($getEnvArray, $name = 'getenv()', $level = 2, $recursive = true);
				$content .= $this->section('getenv():', $out);

				$out = $this->debugvar($GLOBALS['HTTP_ENV_VARS'], $name = 'HTTP_ENV_VARS', $level = 2, $recursive = true);
				$content .= $this->section('HTTP_ENV_VARS:', $out);

				$out = $this->debugvar($GLOBALS['HTTP_SERVER_VARS'], $name = 'HTTP_SERVER_VARS', $level = 2, $recursive = true);
				$content .= $this->section('HTTP_SERVER_VARS:', $out);

				$out = $this->debugvar($GLOBALS['HTTP_COOKIE_VARS'], $name = 'HTTP_COOKIE_VARS', $level = 2, $recursive = true);
				$content .= $this->section('HTTP_COOKIE_VARS:', $out);

			break;


			case 'FE:globjects':
			case 'BE:globjects':
			/*
				$objArray = array();
				while(list($objName,$obj)=each($this))	{
					if(is_object($obj)){
						$objArray['$this->'.$objName] = $obj;
					}
				}
				$out = $this->debugvar($objArray, $name = 'Local Objects', $level = 1, $recursive = true);
				$content .= $this->section('Local Objects', $out);
				$content .= $this->divider();
			*/

				$objArray = array();
				while(list($objName,$obj)=each($GLOBALS))	{
					if(is_object($obj)){
						$objArray['$'.$objName] = $obj;
					}
				}
				$out = $this->debugvar($objArray, $name = 'Global Objects', $level = 1, $recursive = true);
				$content .= $this->section('Global Objects:', $out);
			break;


			case 'FE:debuginfo':

				$sVar = t3lib_div::getIndpEnv('_ARRAY');
				$sVar['CONST: PHP_OS']=PHP_OS;
				$sVar['CONST: TYPO3_OS']=TYPO3_OS;
				$sVar['CONST: PATH_thisScript']=PATH_thisScript;
				$sVar['CONST: php_sapi_name()']=php_sapi_name();
				$sVar['OTHER: TYPO3_VERSION']=$GLOBALS['TYPO_VERSION'];
				$sVar['OTHER: PHP_VERSION']=phpversion();
				$sVar['imagecreatefromgif()']=function_exists('imagecreatefromgif');
				$sVar['imagecreatefrompng()']=function_exists('imagecreatefrompng');
				$sVar['imagecreatefromjpeg()']=function_exists('imagecreatefromjpeg');
				$sVar['imagegif()']=function_exists('imagegif');
				$sVar['imagepng()']=function_exists('imagepng');
				$sVar['imagejpeg()']=function_exists('imagejpeg');
				$sVar['imagettftext()']=function_exists('imagettftext');
				$sVar['OTHER: IMAGE_TYPES']=imagetypes();
				$sVar['OTHER: memory_limit']=get_cfg_var('memory_limit');

				$gE_keys = explode(',','SERVER_PORT,SERVER_SOFTWARE,GATEWAY_INTERFACE,SCRIPT_NAME,PATH_TRANSLATED');
				while(list(,$k)=each($gE_keys))	{
					$sVar['SERVER: '.$k]=$GLOBALS['HTTP_SERVER_VARS'][$k];
				}

				$gE_keys = explode(',','image_processing,gdlib,gdlib_png,gdlib_2,im,im_path,im_path_lzw,im_version_5,im_negate_mask,im_imvMaskState,im_combine_filename');
				while(list(,$k)=each($gE_keys))	{
					$sVar['T3CV_GFX: '.$k]=$GLOBALS['TYPO3_CONF_VARS']['GFX'][$k];
				}

				$debugInfo=array();
				$debugInfo[]='### DEBUG SYSTEM INFORMATION - START ###';
				reset($sVar);
				while(list($kkk,$vvv)=each($sVar))	{
					$debugInfo[]=str_pad(substr($kkk,0,20),20).': '.$vvv;
				}
				$debugInfo[]='### DEBUG SYSTEM INFORMATION - END ###';

				$content .= $this->section('Debug Info:', implode('<br />',$debugInfo));
			break;


			case 'FE:phpinfo':
			case 'BE:phpinfo':
				ob_start();
				phpinfo();
				$infoOut = explode('<body>',ob_get_contents());
				ob_end_clean();
				$infoOut = explode('</body>',$infoOut[1]);
				$out = $infoOut[0];
				$content .= $this->section('PHPInfo:', $out);
			break;
			
		}
		if($content) {
			$content = '<a name="tx_ccinfo_'.$type.'"></a>'.$content;
		}
		return $content;
	}


	function section ($header, $content) {
		global $SOBE;
		
		if(is_object($SOBE)) {
			$content = $SOBE->doc->section($header, $content,0,1);
		} else {
			$content = '<h2>'.htmlspecialchars($header).'</h2>'.$content.'<br />';
		}
		return $content;
	}


	function divider () {
		global $SOBE;
		
		if(is_object($SOBE)) {
			$content = $SOBE->doc->divider();
		} else {
			$content = '<br /><hr /><br />';
		}
		return $content;
	}

	
	/**
	* DebugVar for PHP / Typo3 Development.
	*
	* @author	Luite van Zelst <luite@aegee.org>
	* @link	http://www.xinix.dnsalias.net/fileadmin/t3dev/debugvar.php.txt
	*
	* @access	public
	* @version	1.0
	*
	* @param	mixed	$var	The variable you want to debug. It may be one of these: object, array, boolean, int, float, string
	* @param	string	$name	Name of the variable you are debugging. Usefull to distinguish different debugvar() calls.
	* @param	int		$level	The number of recursive levels to debug. With nested arrays/objects it's the safest thing
	* @internal				 Don't use the recursive param yourself - you'll end up with incomplete tables!
	* @return	string			Returns ready debug output in html-format. Uses nested tables, unfortunately.
	*/
	function &debugvar($var, $name = '', $level = 3, $recursive = false) {
		$style[0] = 'font-size:10px;font-family:verdana,arial;border-collapse:collapse;background:#E7EEEE;';
		$style[1] = 'border-width:1px;border-style:dotted; border-color:#A0AEB0;border-right-style:dotted;';
		$style[2] = 'border-width:1px;border-style:dotted; border-color:#A0AEB0;border-right-style:dotted;border-left-style:dotted;';
		$style[3] = 'border-width:1px;border-style:dotted; border-color:#A0AEB0;border-left-style:dotted;';
		if (@is_null($var)) {
			$type = 'Mixed';
			$var = 'NULL';
			$style[3] .= 'color:red;font-style:italic;';
		} else if(@is_array($var)) {
			$type = 'Array';
			$len = '&nbsp;('. sizeof($var) .')';
			if($level > -1) {
				$multiple = true;
				while(list($key, $val) = each($var)) {
					$line .= $this->debugvar($val, $key, $level - 1, true);
				}
				$var = sprintf("<table style=\"%s\">\n%s\n</table >\n",
					$style[0],
					$line
				);
			} else {
				$var = 'Array not debugged. Set higher "level" if you want to debug this.';
				$style[3] .= 'color:red;font-style:italic;';
			}
			$style[1] .= 'color:grey;font-face:bold;';
			$style[2] .= 'color:grey;font-face:bold;';
			$style[3].= 'padding:0px;';
		} else if(@is_object($var)) {
			$type = @get_class($var);// . '&nbsp;(extends&nbsp;' . @get_parent_class($var) . ')&nbsp;';
			$style[1] .= 'color:purple;';
			$style[3] .= 'color:purple;';
			if($level > -1) {
				$multiple = true;
				$vars = (array) @get_object_vars($var);
				while(list($key, $val) = each($vars)) {
					$line .= $this->debugvar($val, $key, $level -1, true);
				}
				$methods = (array) @get_class_methods($var);
				while(list($key, $val) = each($methods)) {
					$line .= sprintf("<tr ><td style=\"%s\">Method</td ><td colspan=\"2\" style=\"%s\">%s</td ></tr >",
						$style[1],
						$style[3],
						$val . '&nbsp;(&nbsp;)'
					);
				}
				$var = sprintf("<table style=\"%s\">\n%s\n</table >\n",
					$style[0],
					$line
				);
				$len = '&nbsp;('. sizeof($vars) . '&nbsp;+&nbsp;' . sizeof($methods) .')';
			} else {
				$var = 'Object not debugged. Set higher "level" if you want to debug this.';
				$style[3] .= 'color:red;font-style:italic;';
			}
			$style[3].= 'padding:0px;';
		} else if(@is_bool($var)) {
			$type = 'Boolean';
			$style[1] .= 'color:#906;';
			$style[2] .= 'color:#906;';
			if(!$var) $style[3] .= 'color:red;';
			if($var == 0) $var = 'FALSE';
		} else if(@is_float($var)) {
			$type = 'Float';
			$style[1] .= 'color:#066;';
			$style[2] .= 'color:#066;';
		} else if(@is_int($var)) {
			$type = 'Integer';
			$style[1] .= 'color:green;';
			$style[2] .= 'color:green;';
		} else if(@is_string($var)) {
			$type = 'String';
			$style[1] .= 'color:darkblue;';
			$style[2] .= 'color:darkblue;';
			$var = nl2br(@htmlspecialchars($var));
			$len = '&nbsp;('.strlen($var).')';
			if($var == '') $var = '&nbsp;';
		} else {
			$type = 'Unknown!';
			$style[1] .= 'color:red;';
			$style[2] .= 'color:red;';
			$var = @htmlspecialchars($var);
		}
		if(! $recursive) {
			if($name == '') {
				$name = '(no name given)';
				$style[2] .= 'font-style:italic;';
			}
			$style[2] .= 'color:red;';

			if($multiple) {
				$html = "<table cellpadding=1 style=\"%s\">\n<tr >\n<td width=\"0\" style=\"%s\">%s</td ></tr ><tr >\n<td style=\"%s\">%s</td>\n</tr >\n<tr >\n <td colspan=\"2\" style=\"%s\">%s</td>\n</tr >\n</table >\n";
			} else {
				$html = "<table cellpadding=1 style=\"%s\">\n<tr >\n<td style=\"%s\">%s</td>\n<td style=\"%s\">%s</td ><td style=\"%s\">%s</td >\n</tr >\n</table>\n";
			}
			return sprintf($html, $style[0],
				$style[1], $type . $len,
				$style[2], $name,
				$style[3], $var
			);
		} else {
			return	 sprintf("<tr >\n<td style=\"%s\">\n%s\n</td >\n<td style=\"%s\">%s</td >\n<td style=\"%s\">\n%s\n</td ></tr >",
						$style[1],
						$type . $len,
						$style[2],
						$name,
						$style[3],
						$var
					);
		}
	}







	/***************************
	 *
	 * Plugin functions
	 *
	 **************************/
		
	function pi_getInfoOutput() {
		global $TSFE;
		
		$content = '';
		
		$this->pi_mergeOptionsFromSession();
		
		$content = $this->pi_getOptionsForm($this->types);
		$content.= '<br />';
		$content.= $this->pi_getInfo();
		$content = $this->pi_wrapInBaseClass($content);
		
		$TSFE->setCSS($this->prefixCSS, '.'.$this->prefixCSS.'  { margin-top:25px; margin-bottom:25px;  color:black; background-color:#eee; border: 2px #9c1f00 solid; padding:5px; font-weight:normal; text-decoration:none; font-size:12.5px; }');
		
		
		return $content;
	}

	/**
	 * read piVars from user session if not already set (by form)
	 */
	function pi_mergeOptionsFromSession() {		
		$submitted = t3lib_div::_POST($this->prefixId);
		if(is_array($submitted)) {
			$this->selected = $submitted;
		} else {
			$this->selected = $GLOBALS['TSFE']->fe_user->getKey('ses', $this->prefixId);
		}
		$GLOBALS['TSFE']->fe_user->setKey('ses', $this->prefixId, $this->selected);
		$GLOBALS['TSFE']->fe_user->storeSessionData();
	}


	/**
	 * Returns HTML code of an form with some checkbox options
	 */
	function pi_getOptionsForm($options) {
		
		$optDiv = round(count($options)/3);
		
		$content = '';
		
		$content.='
		
			<!--
				'.$this->pObj->prefixId.' options form.
			-->
			<form action="'.htmlspecialchars($this->pObj->pi_getPageLink($GLOBALS['TSFE']->id,'_top')).'" target="_top" method="post" style="margin: 0 0 0 0;">
			<table cellpadding="2" cellspacing="1" border="0">
			<tr><td>
		';
		
		$oc = 0;
		foreach ($options as $option => $optionName) {	
			$oc++;
			$checked = $this->selected[$option]?' checked':'';
			$content.='
				<input type="checkbox"'.$checked.' name="'.$this->prefixId.'['.$option.']" value="1" /> '.$optionName.'<br />
			';
			if(!($oc % $optDiv)) {$content.='
			</td><td>
			';
			}
		}
		
		$content.='
			<input type="hidden" name="no_cache" value="1">
			<input type="submit" name="'.$this->prefixId.'_submit" value="Set options" /><br />
			</td></tr>
			</table>
			</form>
		';		
		
		return $content;
	}
	
	/**
	 * Returns HTML code of info output
	 */
	function pi_getInfo() {
		$content = '';
		
		$count = 0;
		foreach ($this->types as $type => $typeName) {
			if($this->selected[$type]) {
				if($count++) {
					$content .= $this->divider();
				}
				$content .= $this->information($type);
			}
		}
		
		return $content;
	}

	function pi_wrapInBaseClass($str)	{
		return '


	<!--

		BEGIN: Content of extension "'.$this->pObj->extKey.'", plugin "'.$this->pObj->prefixId.'"

	-->
	<div class="'.$this->prefixCSS.'">
		'.$str.'
	</div>
	<!-- END: Content of extension "'.$this->pObj->extKey.'", plugin "'.$this->pObj->prefixId.'" -->

	';
	}
	
}
	
	
 ?>