<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Module extension (addition to function menu) 'Text tools' for the 'cc_textfunc' extension.
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */

// update tablename set field = replace(field,'search_for_this','replace_with_this');


require_once(PATH_t3lib.'class.t3lib_extobjbase.php');
require_once (PATH_t3lib.'class.t3lib_pagetree.php');
require_once (PATH_t3lib.'class.t3lib_tcemain.php');
require_once (t3lib_extMgm::extPath('cc_textfunc').'class.tx_cctextfunc_textstat.php');

class tx_cctextfunc_modfunc1 extends t3lib_extobjbase {

	function modMenu()	{
		global $LANG;
		
		$modMenu = array(
			'tx_cctextfunc_function' => array(
				'find' => $LANG->getLL('find'),
				'sar' => $LANG->getLL('sar'),
				'wc' => $LANG->getLL('wc'),
			),

			'tx_cctextfunc_modfunc1_fstring' => '',
			'tx_cctextfunc_modfunc1_rstring' => '',
			'tx_cctextfunc_modfunc1_searchLevels' => '',
			'tx_cctextfunc_modfunc1_colPos' => '',
			'tx_cctextfunc_modfunc1_colPos_0' => '1',
			'tx_cctextfunc_modfunc1_colPos_1' => '1',
			'tx_cctextfunc_modfunc1_colPos_2' => '1',
			'tx_cctextfunc_modfunc1_colPos_3' => '1',
			'tx_cctextfunc_modfunc1_colPos_4' => '1',
			'tx_cctextfunc_modfunc1_colPos_5' => '1',
			'tx_cctextfunc_modfunc1_incHidden' => '',
			'tx_cctextfunc_modfunc1_queryTable' => '',
			'tx_cctextfunc_modfunc1_queryFields' => '',
			'tx_cctextfunc_modfunc1_regex' => '',
			'tx_cctextfunc_modfunc1_igncase' => '',
			'tx_cctextfunc_modfunc1_includeHTML' => '',
			'tx_cctextfunc_modfunc1_limit' => '50',

			'tx_cctextfunc_modfunc1_storeArray' => '',
			'tx_cctextfunc_modfunc1_storeConfigs' => '',
		);
		return $modMenu;
	}

	function main()	{
			// Initializes the module. Done in this function because we may need to re-initialize if data is submitted!
		global $SOBE,$AB,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$HTTP_GET_VARS,$HTTP_POST_VARS,$CLIENT,$TYPO3_CONF_VARS;

		#debug(t3lib_div::GPvar('SET'));
		#debug($this->pObj->MOD_SETTINGS);

		$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit']=min(200,intval($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit'])?intval($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit']):50);
		$colPosList=$this->getColPosList();
		$this->restoreCheckboxes('tx_cctextfunc_modfunc1_colPos',$colPosList);

		#debug($this->pObj->MOD_SETTINGS);

		$table = $this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_queryTable'];


			// pid select levels
		$sL=intval($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_searchLevels']);
		$queryPermsClause = $GLOBALS['BE_USER']->getPagePermsClause(1);
		$queryPidSelect = $this->getPIDs($this->pObj->id,$sL,$queryPermsClause);

			// init submitted records (checkboxes)
		$queryUidSelect='';
		$this->recs=array();
		$recsUids=array();
		$recs = t3lib_div::GPvar('recs');
		if (is_array($recs)) {
			reset($recs);
			while(list(,$val)=each($recs)) {
				list($tbl,$uid)=explode(':',$val);
				$this->recs[$tbl][$uid]=$uid;
				$recsUids[$uid]=$uid;
			}
			if (count($recsUids)) {
				$queryUidSelect = 'uid IN ('.implode($recsUids,',').')';
			}
		}

			// reStore settings
		$store = t3lib_div::makeInstance('tx_cctextfunc_storeModuleSettings');
		$store->init('tx_cctextfunc_modfunc1_');
		$store->setStoreListFromPrefix('tx_cctextfunc_');
		$storeMsg=$store->procesStoreControl('tx_cctextfunc_modfunc1_');

		$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring'] = stripslashes($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring']);
		$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring'] = stripslashes($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']);

		#debug($this->pObj->MOD_SETTINGS);

			// main menu: text tool funktions
		$out = $LANG->getLL('function').': '.t3lib_BEfunc::getFuncMenu($this->pObj->id,'SET[tx_cctextfunc_function]',$this->pObj->MOD_SETTINGS['tx_cctextfunc_function'],$this->pObj->MOD_MENU['tx_cctextfunc_function']);
		$theOutput.=$this->pObj->doc->section('','<NOBR>'.$out.'</NOBR>');
		$theOutput.=$this->pObj->doc->spacer(5);


			// reStore settings
		if ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=="sar" OR $this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=='find') {
			$theOutput.= $this->pObj->doc->section($LANG->getLL($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']),$store->makeStoreControl(),0,1);
			if ($storeMsg)	{
				$theOutput.= $this->pObj->doc->section('','<strong>'.$storeMsg.'</strong>');
			}
			$theOutput.= $this->pObj->doc->spacer(20);
		} else {
			$theOutput.=$this->pObj->doc->section($LANG->getLL($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']),'',0,1);
		}

			// main search options
		$TDparams = ' bgColor="'.$GLOBALS['TBE_TEMPLATE']->bgColor5.'" nowrap';
		$out='
		<tr>
			<td'.$TDparams.' align="right"><strong>'.$LANG->getLL('searchIn').':</strong><br />&nbsp;</td>
			<td'.$TDparams.'>'.
			$this->mkTableSelect('SET[tx_cctextfunc_modfunc1_queryTable]',$table).' '.
			$this->mkSelect('SET[tx_cctextfunc_modfunc1_queryFields]',$LANG->getLL('searchFields'),$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_queryFields']).
			$this->mkSelect('SET[tx_cctextfunc_modfunc1_searchLevels]',$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.enterSearchLevels',1),$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_searchLevels']).
			'<br /><input type="hidden" name="SET[tx_cctextfunc_modfunc1_incHidden]" value="0" />'.
			'<input type="checkbox" name="SET[tx_cctextfunc_modfunc1_incHidden]" value="1"'.($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_incHidden']?' checked':'').'" /> '.$LANG->getLL('incHidden').
			'</td>
		</tr>';
		$out.='
		<tr>
			<td'.$TDparams.' align="right"><strong>'.$LANG->getLL('columns').':</strong></td>
			<td'.$TDparams.'>'.
			implode(' ',$this->mkCheckboxes('tx_cctextfunc_modfunc1_colPos',$colPosList)).' &nbsp;&nbsp;<span style="color:#666;">('.$LANG->sl($TCA['tt_content']['ctrl']['title']).',...)</span>'.
			'</td>
		</tr>';
		$out = '<table border="0" cellpadding="3" cellspacing="1" width="100%">'.$out.'</table>';


		switch ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']) {

			case 'wc':

				$out .= '<br /><input type="submit" name="startWC" value="'.$LANG->getLL('start').'" />';
				break;

			case 'find':
			case 'sar':
				$menu=array();
					// search form
				$menu[] = $LANG->getLL('searchstring').':<br /><input type="text" name="SET[tx_cctextfunc_modfunc1_fstring]" value="'.htmlspecialchars($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring']).'" size="40" /><br />';
				if ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=='sar') {
					$menu[] = $LANG->getLL('replacestring').':<br /><input type="text" name="SET[tx_cctextfunc_modfunc1_rstring]" value="'.htmlspecialchars($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']).'" size="40" /><br />';
				} else {
					$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']='';
				}
					// regex
				$menu[] = '<input type="hidden" name="SET[tx_cctextfunc_modfunc1_regex]" value="0">
						<input type="checkbox" name="SET[tx_cctextfunc_modfunc1_regex]" value="1"'.($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_regex']?' checked':'').'"> '.$LANG->getLL('useRegex').
						' <a href="'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath('cc_textfunc').'modfunc1/regex7.html" target="blank"><img src="'.$BACK_PATH.'gfx/helpmark.gif" width="12" height="12" border="0" alt="" /></a>';

					// upper/lower case
				$menu[] = '<input type="hidden" name="SET[tx_cctextfunc_modfunc1_igncase]" value="0" />
						<input type="checkbox" name="SET[tx_cctextfunc_modfunc1_igncase]" value="1"'.($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']?' checked':'').'" /> '.$LANG->getLL('ignCase');

					// include HTML
######### excluding of HTML is deactivated
$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_includeHTML'] = TRUE;
$out .=  '<input type="hidden" name="SET[tx_cctextfunc_modfunc1_includeHTML]" value="1" />';
#				$menu[] = '<input type="hidden" name="SET[tx_cctextfunc_modfunc1_includeHTML]" value="0" />
#						<input type="checkbox" name="SET[tx_cctextfunc_modfunc1_includeHTML]" value="1"'.($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_includeHTML']?' checked':'').'" /> '.$LANG->getLL('includeHTML');

					// limit results
				$menu[] = $LANG->getLL('limitResults').': '.$this->mkSelect('SET[tx_cctextfunc_modfunc1_limit]','10:10|25:25|50:50|100:100|200:200',$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit']);

					// submit
				$menu[] = '<input type="submit" name="startFind" value="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.search',1).'" />';


				$TDparams = ' bgColor="'.$GLOBALS['TBE_TEMPLATE']->bgColor4.'" nowrap';
				$out .= '<table border="0" cellpadding="3" cellspacing="1" width="100%"><tr><td'.$TDparams.'>'.implode('</td></tr><tr><td'.$TDparams.'>',$menu).'</td></tr></table>';
			break;
			default:;
		}

		$theOutput.=$this->pObj->doc->section('',$out,0,1);
		$theOutput.=$this->pObj->doc->sectionEnd();
		$theOutput.=$this->pObj->doc->sectionBegin();





		$result = '';

		switch ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']) {

			case 'wc':	// word count

				if (t3lib_div::GPvar('startWC')) {

					$queryFieldList = $this->makeFieldList($table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_queryFields']);
					if ($queryFieldList) {

						$queryFrom = ' FROM '.$table.' WHERE 1=1'.$this->queryColPosSelect($table).' AND '.$queryPidSelect.t3lib_BEfunc::deleteClause($table).$this->hiddenClause($table);
						$query = 'SELECT uid,pid,'.
							($TCA[$table]['ctrl']['typeicon_column']?$TCA[$table]['ctrl']['typeicon_column'].',':'').
							$queryFieldList.$queryFrom;

						$res = mysql(TYPO3_db,$query);
							// make temp file
						$tmpfname = tempnam ('/tmp', 'tx_cctextfunc-');
						$fp = fopen($tmpfname, 'w');

						$count=0;
						while($fp AND $row=mysql_fetch_assoc($res))	{
							$count++;
							unset($row[$TCA[$table]['ctrl']['typeicon_column']]);
							unset($row['uid']);
							unset($row['pid']);
							$txt = $this->stripHTML(implode(chr(10),$row));
							# debug($txt);
							fwrite($fp,$txt);
						}
						fclose($fp);

						if($count)	{
								// header
							$result .= sprintf($LANG->getLL('foundblabla'), '<b>'.$count.'</b>', '<b>'.$LANG->sL($TCA[$table]['ctrl']['title']).'</b> ('.$table.')').'<br /><br />';
								// statistics

							$statTool = 'textstat.php';
							# $statTool = 'wc';
							$statData=array();
							$comment='';
							switch ($statTool) {
							case 'wc':
								$execOut = exec ('/usr/bin/wc -mlLw '.$tmpfname);
								$execOut = t3lib_div::trimExplode(' ',$execOut,1);
								# debug($execOut);
								$statData['num_chars'] = $execOut[2];
								$statData['num_words'] = $execOut[3];
								$statData['num_lines'] = $execOut[0];
								$statData['longest_line'] = $execOut[1];
							break;
							case 'textstat.php':
								$text = t3lib_div::makeInstance('tx_cctextfunc_textstat');
								$text->analyse_file($tmpfname);
								$statData['num_chars']             = $text->num_chars;
								$statData['num_words']             = $text->num_words;
								$statData['num_unique_words']      = count($text->unique_words);
								$statData['percent_complex_words'] = $text->percent_complex_words;
								$statData['num_sentences']         = $text->num_sentences;
								$statData['num_text_lines']        = $text->num_text_lines;
								$statData['num_blank_lines']       = $text->num_blank_lines;
								$statData['num_lines']             = $statData['num_text_lines']+$statData['num_blank_lines'];
								#$statData['longest_line'] = ;
								$statData['num_paragraphs']        = $text->num_paragraphs;
								$statData['syllables_per_word']    = $text->syllables_per_word;
								$statData['words_per_sentence']    = $text->words_per_sentence;
#arsort ($text->unique_words);
#debug($text->unique_words);
#arsort ($text->relevant_words);
#debug($text->relevant_words);
								#$words = $text->unique_words;
								#foreach $word ( sort keys %words )
								#{
								#	print("$words{$word} :$word\n");
								#}

								$statData['fog']     = $text->fog;
								$statData['flesch']  = $text->flesch;
								$statData['kincaid'] = $text->kincaid;
								$comment = '<br /><font size=1 color=grey>'.$LANG->getLL('stat_refersToEn').'</font>';
							break;
							}





							$out = '';
							$cnt=0;
							reset ($statData);
							while (list($key,$val)=each($statData)) {
							$cnt++;
								$val = implode('</td><td align="right" bgcolor="'.$GLOBALS['SOBE']->doc->bgColor4.'">', explode('|', sprintf($LANG->getLL($key),$val)));
								$out .= '<tr bgcolor="'.$GLOBALS['SOBE']->doc->bgColor3.'"><td>'.$val.'</td></tr>';

							}
							$result .= '<table border="0" cellpadding="2" cellspacing="1" width="100%">'.$out.'</table>';
							$result .= $comment;
						} else {
							$result .= $LANG->getLL('noSearchResult');
						}
							// remove tempfile
						unlink($tmpfname);

					} else {
						$result .= $LANG->getLL('noSearchColumns');
					}
				}
				break;



			case 'find':
			case 'sar':	// searching and result

				if (trim($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring']) AND t3lib_div::GPvar('startFind') OR ($doReplace=t3lib_div::GPvar('startReplace'))) {


					$queryFieldList = $this->makeFieldList($table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_queryFields']);
					$fieldArr = t3lib_div::trimExplode(',',$queryFieldList,1);

					if ($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_regex']) {
						$qString = $this->searchQuery(array($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring']),$fieldArr, 'regex', !$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']);
					} else {
						$qString = $this->searchQuery(array($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring']),$fieldArr, 'like', !$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']);
					}


					if ($queryFieldList) {

						if ($doReplace AND $queryUidSelect) {
							$queryFrom = ' FROM '.$table.' WHERE '.$queryUidSelect.t3lib_BEfunc::deleteClause($table);
							$query = 'SELECT uid,pid,'.$queryFieldList.$queryFrom;
							$res = mysql(TYPO3_db,$query);
							# debug($query);
							while($row=mysql_fetch_assoc($res))	{
								$this->replaceText($row,$TCA[$table],$table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring'],$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_regex'],$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']);
							}
						}

							// Count:
						$queryFrom = ' FROM '.$table.' WHERE'.$qString.$this->queryColPosSelect($table).' AND '.$queryPidSelect.t3lib_BEfunc::deleteClause($table).$this->hiddenClause($table);
						$orderBy = ' ORDER BY pid'.(($TCA[$table]['ctrl']['sortby']) ? ','.$TCA[$table]['ctrl']['sortby'] : ','.$TCA[$table]['ctrl']['default_sortby']);
						$query = 'SELECT count(*) '.$queryFrom;
						# debug($query);
						$res = mysql(TYPO3_db,$query);
						echo mysql_error();
						list($count)=mysql_fetch_row($res);
						if($count)	{

								// Output header:
							if ($count > $this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit']) {
								$result.=sprintf($LANG->getLL('foundblablaExcerpt'), "<b>".$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit']."</b>", "<b>".$count."</b>", "<b>".$LANG->sL($TCA[$table]['ctrl']['title']).'</b> ('.$table.')').'<br /><br />';
							} else {
								$result.=sprintf($LANG->getLL('foundblabla'), "<b>".$count."</b>", "<b>".$LANG->sL($TCA[$table]['ctrl']['title']).'</b> ('.$table.')').'<br /><br />';
							}

							$query = 'SELECT uid,pid,'.
								($TCA[$table]['ctrl']['typeicon_column']?$TCA[$table]['ctrl']['typeicon_column'].',':'').
								$queryFieldList.$queryFrom.$orderBy.' LIMIT '.$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_limit'];
							$res = mysql(TYPO3_db,$query);

							$rowArr=array();
							while($row=mysql_fetch_assoc($res))	{
								$rowArr[]=$this->resultRowDisplay($row,$TCA[$table],$table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_fstring'],$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_regex'],$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']);
								$lrow=$row;
							}

							if ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=='sar') {
								$result.= $this->JSsetCheckboxes();
								$result .= '<table border=0 cellpadding=2 cellspacing=1 width="100%">'.$this->resultRowTitles($lrow,$TCA[$table],$table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']).implode(chr(10),$rowArr).$this->resultRowTitles($lrow,$TCA[$table],$table,$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_rstring']).'</table>';
								$result .= '<br /><input type="submit" name="startReplace" value="'.$LANG->getLL('replace').'" />';
							} else {
								$result .= '<table border=0 cellpadding=2 cellspacing=1 width="100%">'.$this->resultRowTitles($lrow,$TCA[$table],$table).implode(chr(10),$rowArr).$this->resultRowTitles($lrow,$TCA[$table],$table).'</table>';
							}
						} else {
							$result .= $LANG->getLL('noSearchResult');
						}
					} else {
						$result .= $LANG->getLL('noSearchColumns');
					}
				}
			break;
			default:
				$result .= '';
		}

		if ($result) {
			# $result .= '<br /><br /><HR><span style="font-size:9px;color:#999;">'.str_replace(',',', ',$query).'</span>';

			$theOutput.=$this->pObj->doc->spacer(10);
			$theOutput.=$this->pObj->doc->section($LANG->getLL('result'),$result,1,2);
		}

		$theOutput.=$this->pObj->doc->spacer(10);
		return $theOutput;
	}





	//
	// PROCESSING -------------------------------------
	//

	/**
	 *
	 */
	function replaceText($row,$conf,$table,$sword='',$stype='',$replace='') {
		global $LANG, $TCA, $BACK_PATH, $BE_USER;

		$swordEreg = $this->preEreg($sword);
		$replaceEreg = $this->preEreg($replace);

		/* ----- from alt_doc.php begin -------- */

		$tce = t3lib_div::makeInstance('t3lib_TCEmain');

		// ***************************
		// Checking referer / executing
		// ***************************
		$refInfo=parse_url(t3lib_div::getIndpEnv('HTTP_REFERER'));
		$httpHost = t3lib_div::getIndpEnv('TYPO3_HOST_ONLY');
		if ($httpHost!=$refInfo['host'] && t3lib_div::GPvar('vC')!=$BE_USER->veriCode() && !$TYPO3_CONF_VARS['SYS']['doNotCheckReferer'])	{
			$tce->log('',0,0,0,1,"Referer host '%s' and server host '%s' did not match and veriCode was not valid either!",1,array($refInfo['host'],$httpHost));
			debug('Error: Referer host did not match with server host.');
			return;
		}

		$TCAdefaultOverride = $BE_USER->getTSConfigProp('TCAdefaults');
		if (is_array($TCAdefaultOverride))	{
			$tce->setDefaultsFromUserTS($TCAdefaultOverride);
		}

		$tce->debug=0;
		$tce->disableRTE=t3lib_div::GPvar('_disableRTE');

		/* ----- from alt_doc.php end -------- */

		if ($this->recs[$table][$row['uid']]) {
			$uid=$row['uid'];
			unset($row[$TCA[$table]['ctrl']['typeicon_column']]);
			unset($row['uid']);
			unset($row['pid']);

			$fUpdated=array();

			reset($row);
			while(list($fN,$fV)=each($row))	{

				$fVnew = $fV;
				if ($fVnew AND ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=='sar')) {
					if ($stype AND !$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {	// regex
						if (ereg ($swordEreg,$fVnew)) {
							$fUpdated[$fN] = ereg_replace ($swordEreg, $replaceEreg, $fVnew);
						}
					} if ($stype AND $this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {
						if (eregi ($swordEreg,$fVnew)) {
							$fUpdated[$fN] = eregi_replace ($swordEreg, $replaceEreg, $fVnew);
						}

					} elseif ($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {
						if (stristr($fVnew,$sword)) {
							#$fUpdated[$fN] = str_replace ($sword, $replace, $fVnew);
							$fUpdated[$fN] = eregi_replace (quotemeta ($sword), $replace, $fVnew);
						}
					} else {
						if (strstr($fVnew,$sword)) {
							$fUpdated[$fN] = str_replace ($sword, $replace, $fVnew);
						}
					}
				}
			}
			if (count($fUpdated)) {
				# old
				# $query = t3lib_befunc::DBcompileUpdate($table,"uid=".$uid,$fUpdated);
				# $res = mysql(TYPO3_db,$query);

				$tce->start(array($table=>array($uid=>$fUpdated)),array());
# debug($tce->datamap);

				# ???
				# if (is_array($this->mirror))	{$tce->setMirror($this->mirror);}

				if ($table=='pages')	{
					t3lib_BEfunc::getSetUpdateSignal('updatePageTree');
				}

				$tce->process_datamap();

			}
		}

	}





	//
	// DB/SQL ---------------------------------------------
	//

	/**
	 *
	 */
	function searchQuery($searchWords,$fields,$function='like',$caseSensitive=false)	{
		reset($searchWords);
		$queryParts=array();
		while(list(,$sw)=each($searchWords))	{
#			$sw=addslashes($sw);
			switch($function)	{
				case 'regex':
					if ($caseSensitive) {
						$like=" REGEXP BINARY '".$sw."'";
					} else {
						$like=" REGEXP '".$sw."'";
					}
				break;
				case 'like':
				default:
					$sw=addslashes($sw);
					if ($caseSensitive) {
						$like=" LIKE BINARY '%".$sw."%'";
					} else {
						$like=" LIKE '%".$sw."%'";
					}
				break;
			}
			$queryParts[] = implode($like.' OR ',$fields).$like;
		}
		$query = '('.implode(') AND (',$queryParts).')';
		#debug($query);
		return $query;
	}


	/**
	 *
	 */
	function makeFieldList($table, $onlyTextarea)	{
		global $TCA;

		$fieldListArr = array();
		if (is_array($TCA[$table]))	{
			t3lib_div::loadTCA($table);
			reset($TCA[$table]['columns']);
			while(list($fN,$fC)=each($TCA[$table]['columns']))	{


				if (is_array($fC))	{
					switch($fC['config']['type'])	{
						case 'input':
							if (eregi('int|year',$fC['config']['eval']))	{
							} elseif (eregi('date|time',$fC['config']['eval']))	{
							} else {
								if (!$onlyTextarea) {$fieldListArr[]=$fN;}
							}
						break;
						case 'check':
						case 'select':
						break;
						case 'text':
							$fieldListArr[]=$fN;
						break;
						default:
						break;
					}
				}
			}
		}
		return implode(',',$fieldListArr);
	}


	/**
	 *
	 */
	function getPIDs($id,$depth,$perms_clause)	{
		if ($depth>0)	{
			$tree = t3lib_div::makeInstance('t3lib_pageTree');
			$tree->init('AND '.$perms_clause);
			$tree->makeHTML=0;
			$tree->fieldArray = Array('uid','php_tree_stop');
			if ($depth)	{
				$tree->getTree($id, $depth, '');
			}
			$tree->ids[]=$id;
			$queryPidSelect = 'pid IN ('.implode($tree->ids,',').')';
		} else {
			$queryPidSelect = 'pid='.intval($id);
		}

		return $queryPidSelect;
	}

	/**
	 *
	 */
	function queryColPosSelect($table) {
		global $TCA;

		if (is_array($TCA[$table]['columns']['colPos']['config']['items']))	{
			$cols='';
			reset($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_colPos']);
			while(list($key,$val)=each($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_colPos'])) {
				if ($val) {
					$cols.=','.$key;
				}
			}
			return $cols?' AND '.$table.'.colPos IN ('.preg_replace('/^,/','',$cols).')':'';
		}
	}

	function hiddenClause($table)	{
		global $TCA;
		if ($TCA[$table]['ctrl']['enablecolumns']['disabled'])	{
			if (!$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_incHidden']) {
				return ' AND NOT '.$table.'.'.$TCA[$table]['ctrl']['enablecolumns']['disabled'];
			}
		}
		return '';
	}


	//
	// HTML & FORMS -----------------------------------
	//

	/**
	 *
	 */
	function mkTableSelect($name,$cur)	{
		global $LANG, $TCA, $BACK_PATH, $BE_USER;

		//		$out='<select name="'.$name.'" onChange="submit();">';
		$out='<select name="'.$name.'">';
		$tN='tt_content';
		$out.='<option value="'.$tN.'"'.($tN==$cur ? ' selected':'').'>'.$LANG->sl($TCA[$tN]['ctrl']['title']).'</option>';
		$tN='pages';
		$out.='<option value="'.$tN.'"'.($tN==$cur ? ' selected':'').'>'.$LANG->sl($TCA[$tN]['ctrl']['title']).'</option>';
		$out.='<option value="">-------------</option>';

		reset($TCA);
		while(list($tN)=each($TCA)) {
			if ($BE_USER->check('tables_select',$tN))	{
				$out.='<option value="'.$tN.'"'.($tN==$cur ? ' selected':'').'>'.$LANG->sl($TCA[$tN]['ctrl']['title']).'</option>';
			}
		}
		$out.='</select>';
		return $out;
	}

	/**
	 *
	 */
	function mkSelect($name,$def,$cur)	{
		if (is_array($def)) {
			$options = $def;
		} else {
			$options = explode('|',$def);
		}
		$out='<select name="'.$name.'">';
		reset($options);
		while(list($cnt,$tN)=each($options)) {
			if (is_array($def)) {
				$title = $cnt;
				$val = $tN;
			} else {
				list($title,$val)=explode(':',$tN);
			}
			if (!isset($val)) { $val = $cnt;}
			$out.='<option value="'.$val.'"'.($val==$cur ? ' selected':'').'>'.$title.'</option>';
		}
		$out.='</select>';
		return $out;
	}


	/**
	 *
	 */
	function mkCheckboxes($name,$options)	{

		$menu=array();
		reset($options);
		while(list($title,$val)=each($options)) {
			$menu[] = '<input type="hidden" name="SET['.$name.'_'.$val.']" value="0" />
					<input type="checkbox" name="SET['.$name.'_'.$val.']" value="1"'.($this->pObj->MOD_SETTINGS[$name][$val]?' checked':'').'" /> '.$title;
		}
		return $menu;
	}
	/**
	 *
	 */
	function restoreCheckboxes($name,$options)	{
		$this->pObj->MOD_SETTINGS[$name]=array();
		reset($options);
		while(list(,$val)=each($options)) {
			$this->pObj->MOD_SETTINGS[$name][$val]=$this->pObj->MOD_SETTINGS[$name.'_'.$val];
		}
	}

	//
	// OUTPUT ------------------------------------------
	//

	/**
	 *
	 */
	function resultRowTitles($row,$conf,$table,$replace='')	{
		global $LANG, $TCA, $BACK_PATH;

		unset($row[$TCA[$table]['ctrl']['typeicon_column']]);
		unset($row['uid']);
		unset($row['pid']);

		$out='<tr bgcolor="'.$GLOBALS['SOBE']->doc->bgColor5.'">';
		if ($replace) {
			$out.='<td nowrap>&nbsp;<a href="#" onclick="setCheckboxes(0); return false;"><img src="'.$BACK_PATH.'gfx/clip_select.gif" width="12" height="12" border="0" '.t3lib_BEfunc::titleAttrib($LANG->getLL('clip_markRecords')).' /></a></td>';
		} else {
			$out.='<td nowrap>&nbsp;</td>';
		}
		reset($row);
		while(list($fN,$fV)=each($row))	{
			if ($fN=='uid') $fN='id';
			if ($fN=='pid') $fN=$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.path',1);
			if (strlen($fV)<50)		{$TDparams = ' nowrap';} else {$TDparams = '';}
			$out.='<td'.$TDparams.'><strong>'.htmlspecialchars($LANG->sL($conf['columns'][$fN]['label']?$conf['columns'][$fN]['label']:$fN)).'</strong></td>';
		}
		$out.='</tr>';
		return $out;
	}

	/**
	 *
	 */
	function resultRowDisplay($row,$conf,$table,$sword='',$stype="",$replace='')	{
		global $LANG, $TCA, $BACK_PATH, $BE_USER;

		$swordEreg = $this->preEreg($sword);
		$replaceEreg = $this->preEreg($replace);

		$pid = ($table=='pages') ? $row['uid'] : $row['pid'];
		$uid = $row['uid'];

		$out='<tr bgcolor="'.$GLOBALS['SOBE']->doc->bgColor4.'">';

		$typeIcon = '<img src="'.$BACK_PATH.t3lib_iconWorks::getIcon($table,$row).'" width="18" height="16" border="0" align="middle" />';

		$params = '&edit['.$table.']['.$row['uid'].']=edit';
		$icons ='<a href="#" onClick="top.launchView(\''.$table.'\','.$uid.',\''.$BACK_PATH.'\');return false;"><img src="'.$BACK_PATH.'gfx/zoom2.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($LANG->sL('LLL:EXT:lang/locallang_mod_web_list.php:showInfo')).' hspace="1" /></a>';
		$icons.='<a href="#" onClick="'.t3lib_BEfunc::viewOnClick($pid,$BACK_PATH,t3lib_BEfunc::BEgetRootLine($pid)).';return false;"><img src="'.$BACK_PATH.'gfx/zoom.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPage',1)).' hspace="1" /></a>';
		$icons.='<a href="#" onClick="'.t3lib_BEfunc::editOnClick($params,$BACK_PATH,t3lib_div::getIndpEnv('REQUEST_URI').'?'.t3lib_div::implodeArrayForUrl('SET',$GLOBALS['HTTP_POST_VARS']['SET']),1).'"><img src="'.$BACK_PATH.'gfx/edit2.gif" width="11" height="12" border="0"'.t3lib_BEfunc::titleAttrib($LANG->sL('LLL:EXT:lang/locallang_mod_web_list.php:edit')).' hspace="1" /></a>';
		$icons.='<a href="#" onClick="vHWin=window.open(\''.t3lib_div::linkThisUrl($BACK_PATH.'alt_doc.php',array('returnUrl'=>'close.html','edit['.$table.']['.$uid.']'=>'edit')).'\',\''.md5(t3lib_div::getIndpEnv('TYPO3_REQUEST_SCRIPT')).'\',\''.($BE_USER->uc['edit_wideDocument']?'width=670,height=500':'width=600,height=400').',status=0,menubar=0,scrollbars=1,resizable=1\');vHWin.focus();return false;"><img src="'.$BACK_PATH.'gfx/open_in_new_window.gif" width="19" height="14" hspace="1" border="0"'.t3lib_BEfunc::titleAttrib($LANG->sL('LLL:EXT:lang/locallang_core.php:labels.openInNewWindow',1)).' /></a>';

		$info = $typeIcon.' id='.$uid.'<br />'.$this->getProcessedValueExtra($table,'pid',$pid).'<br />'.'Seiten ID: '.$pid.'<br />';
		$out.='<td nowrap valign="top">';
		$doReplace = ($this->pObj->MOD_SETTINGS['tx_cctextfunc_function']=='sar');
		if ($doReplace) {
			$out.='<input type="checkbox" name="recs[]" value="'.$table.':'.$uid.'"'.($recs[$table.'_'.$uid]?' checked':'').' /><br /><br />';
		}
		$out .= $info.'<br />'.$icons.'</td>';

		unset($row[$TCA[$table]['ctrl']['typeicon_column']]);
		unset($row['uid']);
		unset($row['pid']);

		reset($row);
		while(list($fN,$fV)=each($row))	{
			$TDparams = ' valign="top"';

			# $fVnew = $this->getProcessedValueExtra($table,$fN,$fV,!$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_includeHTML']);
			$fVnew = $this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_includeHTML']?$fV:$this->stripHTML($fV);

				// regex
			if ($stype AND !$this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {	// regex
				if (ereg ($swordEreg,$fVnew)) {
					$fout = ereg_replace ('('.$swordEreg.")", '###tx_cctextfunc-SPAN_RED###\\1###tx_cctextfunc-SPAN_END###', $fVnew);
					if ($fVnew AND $doReplace) {
						$fout .= '###tx_cctextfunc-SPLIT###'.ereg_replace ($swordEreg,'###tx_cctextfunc-SPAN_GREEN###'.$replaceEreg.'###tx_cctextfunc-SPAN_END###',$fVnew);
					}
				} else {
					$fout = $fVnew;
				}

				// regex - ignore case
			} elseif ($stype AND $this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {	// regex
				if (eregi ($swordEreg,$fVnew)) {
					$fout = eregi_replace ('('.$swordEreg.")", '###tx_cctextfunc-SPAN_RED###\\1###tx_cctextfunc-SPAN_END###', $fVnew);
					if ($fVnew AND $doReplace) {
						$fout .= '###tx_cctextfunc-SPLIT###'.eregi_replace ($swordEreg,'###tx_cctextfunc-SPAN_GREEN###'.$replaceEreg.'###tx_cctextfunc-SPAN_END###',$fVnew);
					}
				} else {
					$fout = $fVnew;
				}

				// str_replace - ignore case
			} elseif ($this->pObj->MOD_SETTINGS['tx_cctextfunc_modfunc1_igncase']) {
				if (stristr($fVnew,$sword)) {
					$fout = eregi_replace ('('.quotemeta ($sword).")",'###tx_cctextfunc-SPAN_RED###\\1###tx_cctextfunc-SPAN_END###', $fVnew);
					if ($fVnew AND $doReplace) {
						 $fout .= '###tx_cctextfunc-SPLIT###'.eregi_replace (quotemeta ($sword),'###tx_cctextfunc-SPAN_GREEN###'.$replace.'###tx_cctextfunc-SPAN_END###', $fVnew);
					}
				} else {
					$fout = $fVnew;
				}

				// str_replace
			} else {
				if (strstr($fVnew,$sword)) {
					$fout = str_replace ($sword,'###tx_cctextfunc-SPAN_RED###'.$sword.'###tx_cctextfunc-SPAN_END###', $fVnew);
					if ($fVnew AND $doReplace) {
						$fout .= '###tx_cctextfunc-SPLIT###'.str_replace ($sword,'###tx_cctextfunc-SPAN_GREEN###'.$replace.'###tx_cctextfunc-SPAN_END###', $fVnew);
					}
				} else {
					$fout = $fVnew;
				}
			}
			$trans = array ('###tx_cctextfunc-SPAN_RED###' => '<span style="color:red;font-weight:bold;">',
							'###tx_cctextfunc-SPAN_GREEN###' => '<span style="color:green;font-weight:bold;">',
							'###tx_cctextfunc-SPAN_END###' => '</span>',
							'###tx_cctextfunc-SPLIT###' => '<hr>',
							"\n" => '&para;<br />');
			$fout = strtr(htmlspecialchars($fout), $trans);
			$out.='<td'.$TDparams.'>'.$fout.'</td>';
		}
		$out.='</tr>';
		return $out;
	}



	/**
	 *
	 */
	function JSsetCheckboxes()	{
		return <<<EOD
		<script type="text/javascript" language="javascript">
		<!--
		function setCheckboxes(the_form)
		{
			var elts      = document.forms[the_form].elements['recs[]'];
			var elts_cnt  = (typeof(elts.length) != 'undefined')
						? elts.length
						: 0;

			if (elts_cnt) {
				do_check = !elts[0].checked;
				for (var i = 0; i < elts_cnt; i++) {
					elts[i].checked = do_check;
				}
			} else {
				elts.checked = !elts.checked;
			}
			return true;
		}
		//-->
		</script>
EOD;
	}






	//
	// TOOLS -----------------------------------------
	//


	/**
	 *
	 */
	function getColPosList() {
		global $TCA, $LANG;

		$modTSconfig_SHARED = t3lib_BEfunc::getModTSconfig($this->pObj->id,'mod.SHARED');		// SHARED page-TSconfig settings.
		$colPosList = $modTSconfig_SHARED['properties']['colPos_list'];
		$colPosList = strcmp($colPosList,'')?$colPosList:"1,0,2,3";
		$colPosList = t3lib_div::intExplode(',',$colPosList);

		$colList=array();
		if (is_array($TCA['tt_content']['columns']['colPos']['config']['items']))	{
			reset($TCA['tt_content']['columns']['colPos']['config']['items']);
			while(list(,$temp)=each($TCA['tt_content']['columns']['colPos']['config']['items']))	{
				if (in_array($temp[1],$colPosList)) {
					$colList[$LANG->sL($temp[0])]=$temp[1];
				}
			}
		}
		//debug($colList);
		return $colList;
	}

	/**
	 *
	 */
	function getProcessedValueExtra($table,$fN,$fV,$stripTags=0)	{
		global $TCA;
		$fVnew = t3lib_BEfunc::getProcessedValue($table,$fN,$fV,0,1);
		if (!isset($fVnew))	{
			if (is_array($TCA[$table]))	{
				if ($fN==$TCA[$table]['ctrl']['tstamp'] || $fN==$TCA[$table]['ctrl']['crdate'])	{
					$fVnew = t3lib_BEfunc::datetime($fV);
				} elseif ($fN=='pid'){
					$fVnew = t3lib_BEfunc::getRecordPath ($fV,'1',20);	// Fetches the path with no regard to the users permissions to select pages.
				} else {
					$fVnew = $fV;
				}
			}
		}
		return $stripTags?$this->stripHTML($fVnew):$fVnew;
	}


	/**
	 * This will remove HTML tags, javascript sections
	 * and white space. It will also convert some
	 * common HTML entities to their text equivalent.
	 */
	function stripHTML($txt)	{

		return strip_tags(strtr($txt, array_flip(get_html_translation_table(HTML_ENTITIES))));

		############
		$search = array ("'<script[^>]*?>.*?</script>'si",  // Strip out javascript
						"'<[\/\!]*?[^<>]*?>'si",           // Strip out html tags
						"'([\r\n])[\s]+'",                 // Strip out white space
						"'&(quot|#34);'i",                 // Replace html entities
						"'&(amp|#38);'i",
						"'&(lt|#60);'i",
						"'&(gt|#62);'i",
						"'&(nbsp|#160);'i",
						"'&(iexcl|#161);'i",
						"'&(cent|#162);'i",
						"'&(pound|#163);'i",
						"'&(copy|#169);'i",
						"'&#(\d+);'e");                    // evaluate as php

		$replace = array ('',
						'',
						"\\1",
						"\"",
						'&',
						'<',
						'>',
						' ',
						chr(161),
						chr(162),
						chr(163),
						chr(169),
						"chr(\\1)");

		return preg_replace ($search, $replace, $txt);
	}


	function preEreg ($val) {
		$val=str_replace('\n',"\n",$val);
		$val=str_replace('\r',"\r",$val);
		$val=str_replace('\t',"\t",$val);
		return $val;
	}

}







class tx_cctextfunc_storeModuleSettings {

	var $prefix='';

	function init($prefix="",$storeList='')	{
		$this->prefix = $prefix;
		$this->storeList = $storeList;
	}

	function setStoreListFromPrefix ($prefix='') {
		$prefix = $prefix ? $prefix : $this->prefix;
		$storeList = array();
		reset($GLOBALS['SOBE']->MOD_SETTINGS);

		while(list($key)=each($GLOBALS['SOBE']->MOD_SETTINGS))	{
			if (ereg('^'.$prefix,$key)) {
				$storeList[$key]=$key;
			}
		}
		unset($storeList[$this->prefix.'storeArray']);
		unset($storeList[$this->prefix.'storeConfigs']);
		$this->storeList = implode($storeList,',');
	}

	function makeStoreControl()	{
			// Load/Save
		$storeArray = $this->initStoreArray();
		$cur='';

			// Store Array:
		$opt=array();
		reset($storeArray);
		while(list($k,$v)=each($storeArray))	{
			$opt[]='<option value="'.$k.'"'.(!strcmp($cur,$v)?" selected":"").'>'.htmlspecialchars($v).'</option>';
		}

			// Actions:
		if (t3lib_extMgm::isLoaded('sys_action'))	{
			$query = 'SELECT * FROM sys_action WHERE type=2 ORDER BY title';
			$res = mysql(TYPO3_db,$query);
			if (mysql_num_rows($res))	{
				$opt[]='<option value="0">__Save to Action:__</option>';
				while($row=mysql_fetch_assoc($res))	{
					$opt[]='<option value="-'.$row['uid'].'"'.(!strcmp($cur,"-".$row['uid'])?" selected":"").'>'.htmlspecialchars($row['title'].' ['.$row['uid'].']').'</option>';
				}
			}
		}

		$TDparams=' nowrap bgcolor="'.$GLOBALS['TBE_TEMPLATE']->bgColor4.'"';
		$tmpCode='
		<table border=0 cellpadding=3 cellspacing=1 width="100%">
		<tr'.$TDparams.'>
		<td>Preset:</td>
		<td nowrap><select name="storeControl[STORE]" onChange="document.forms[0][\'storeControl[title]\'].value= this.options[this.selectedIndex].value!=0 ? this.options[this.selectedIndex].text : \'\';">'.implode(chr(10),$opt).'</select><input type="submit" name="storeControl[LOAD]" value="Load" /> <input type="submit" name="storeControl[REMOVE]" value="Remove" /> &nbsp;&nbsp;</td>
		<td nowrap><input name="storeControl[title]" value="" type="text" max=80 width="25" /><input type="submit" name="storeControl[SAVE]" value="Save" onClick="if (document.forms[0][\'storeControl[STORE]\'].options[document.forms[0][\'storeControl[STORE]\'].selectedIndex].value<0) return confirm(\'Are you sure you want to overwrite the existing query in this action?\');" /></td></tr>
		</table>
		';
		return $tmpCode;
	}
	function initStoreArray()	{
		$storeArray=array(
			'0' => ' '
		);

		$savedStoreArray = unserialize($GLOBALS['SOBE']->MOD_SETTINGS[$this->prefix.'storeArray']);

		if (is_array($savedStoreArray))	{
			$storeArray = array_merge($storeArray,$savedStoreArray);
		}
		return $storeArray;
	}
	function cleanstoreConfigs($storeConfigs,$storeArray)	{
		if (is_array($storeConfigs))	{
			reset($storeConfigs);
			while(list($k,$v)=each($storeConfigs))	{
				if (!isset($storeArray[$k]))	unset($storeConfigs[$k]);
			}
		}
		return $storeConfigs;
	}



	function addTostoreConfigs($storeConfigs,$index)	{
		$keyArr = explode(',',$this->storeList);
		reset($keyArr);
		$storeConfigs[$index]=array();
		while(list(,$k)=each($keyArr))	{
			$storeConfigs[$index][$k]=$GLOBALS['SOBE']->MOD_SETTINGS[$k];
		}
		return $storeConfigs;
	}
	function saveQueryInAction($uid)	{
		if (t3lib_extMgm::isLoaded('sys_action'))	{
		}
	}
	function loadstoreConfigs($storeConfigs,$storeIndex,$writeArray)	{
		if ($storeConfigs[$storeIndex])	{
			$keyArr = explode(',',$this->storeList);
			reset($keyArr);
			while(list(,$k)=each($keyArr))	{
				$writeArray[$k]=$storeConfigs[$storeIndex][$k];
			}
		}
		return $writeArray;
	}
	function procesStoreControl()	{
		$storeArray = $this->initStoreArray();
		$storeConfigs = unserialize($GLOBALS['SOBE']->MOD_SETTINGS[$this->prefix.'storeConfigs']);

		$storeControl = t3lib_div::GPvar('storeControl');
		$storeIndex = intval($storeControl['STORE']);


#debug($GLOBALS['SOBE']->MOD_SETTINGS);
#debug($storeArray);
#debug($storeConfigs);
#debug($storeControl);
#debug($this->storeList);

		$saveStoreArray=0;
		$writeArray=array();
		if (is_array($storeControl))	{
			$storeControl = t3lib_div::slashArray($storeControl,'strip');
			if ($storeControl['LOAD'])	{
				if ($storeIndex>0)	{
					$writeArray=$this->loadstoreConfigs($storeConfigs,$storeIndex,$writeArray);
					$saveStoreArray=1;
					$msg="'".$storeArray[$storeIndex]."' query loaded!";
				} elseif ($storeIndex<0 && t3lib_extMgm::isLoaded('sys_action'))	{
					$actionRecord=t3lib_BEfunc::getRecord('sys_action',abs($storeIndex));
					if (is_array($actionRecord))	{
						$dA = unserialize($actionRecord['t2_data']);
						$dbSC=array();
						if (is_array($dA['qC']))	{
							$dbSC[0] = $dA['qC'];
						}
						$writeArray=$this->loadstoreConfigs($dbSC,'0',$writeArray);
						$saveStoreArray=1;
						$acTitle=htmlspecialchars($actionRecord['title']);
						$msg="Query from action '".$acTitle."' loaded!";
					}
				}
			} elseif ($storeControl['SAVE'])	{
				if ($storeIndex<0)	{
					$qOK = $this->saveQueryInAction(abs($storeIndex));
					if ($qOK)	{
						$msg='Query OK and saved.';
					} else {
						$msg='No query saved!';
					}
				} else {
					if (trim($storeControl['title']))	{
						if ($storeIndex>0)	{
							$storeArray[$storeIndex]=$storeControl['title'];
						} else {
							$storeArray[]=$storeControl['title'];
							end($storeArray);
							$storeIndex=key($storeArray);
						}
						$storeConfigs=$this->addTostoreConfigs($storeConfigs,$storeIndex);
						$saveStoreArray=1;
						$msg="'".$storeArray[$storeIndex]."' query saved!";
					}
				}
			} elseif ($storeControl['REMOVE'])	{
				if ($storeIndex>0)	{
					$msg="'".$storeArray[$storeControl['STORE']]."' query entry removed!";
					unset($storeArray[$storeControl['STORE']]);	// Removing
					$saveStoreArray=1;
				}
			}
		}
		if ($saveStoreArray)	{
			unset($storeArray[0]);	// making sure, index 0 is not set!
			$writeArray[$this->prefix.'storeArray']=serialize($storeArray);
			$writeArray[$this->prefix.'storeConfigs']=serialize($this->cleanstoreConfigs($storeConfigs,$storeArray));
			$GLOBALS['SOBE']->MOD_SETTINGS = t3lib_BEfunc::getModuleData($GLOBALS['SOBE']->MOD_MENU, $writeArray, $GLOBALS['SOBE']->MCONF['name'], 'ses');
#debug($GLOBALS['SOBE']->MCONF['name']);
#debug($writeArray);
#debug($GLOBALS['SOBE']->MOD_SETTINGS);
		}
		return $msg;
	}

}







if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cc_textfunc/modfunc1/class.tx_cctextfunc_modfunc1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cc_textfunc/modfunc1/class.tx_cctextfunc_modfunc1.php']);
}

?>
