<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Ren Fritz ()
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Examine Server' for the 'user_exm_sv' extension.
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class user_exmsv_pi1 extends tslib_pibase {
	var $prefixId = 'user_exmsv_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.user_exmsv_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'user_exm_sv';	// The extension key.
	
	/**
	 * Examine Server main function
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_USER_INT_obj=1;
			
		$domain = $this->piVars['domain'];

		$result = $this->examine($domain);
		
		if($result && !strstr($result, 'ERROR')) {
			$result = '
				<hr>
				<p>'.htmlspecialchars($domain).' is running:<br />
				<br />
				'.$result.'</p>';
		}
		
		$content = '
			<h2>Examine Server</h2>
			<form action="'.htmlspecialchars(t3lib_div::getIndpEnv('REQUEST_URI')).'" method="post">
				<p>Enter a domain name to examine their server:
				<input type="text" name="'.$this->prefixId.'[domain]" value="'.htmlspecialchars($domain).'">
				<input type="hidden" name="no_cache" value="1" />
				<input type="submit" value="Go"></p>
			</form>'.$result;
	
		return $this->pi_wrapInBaseClass($content);
	}
	

	/**
	 * Examine server informatione with GET request
	 *
	 * @param 	string 	domain name
	 * @return 	string 	
	 */	
	function examine($domain){
		$result = '';
		
		if($domain){
			if($fp = @fsockopen($domain, 80, &$errno, &$errstr, 30)){
				fputs($fp, "GET / HTTP/1.0\r\n\r\n");
				$data = array();
				while(!feof($fp)) {
					$data[] = fgets($fp, 128);
				}
				fclose ($fp);
			}
			
			for($x=0; $x<7; $x++) {
				$result = (strstr(strtolower($data[$x]), 'server:'))?$data[$x]:$result;
			}
			$result .= (strstr($data[3], 'X-Powered-By'))?'<br />'.$data[3]:'';		
		}
	
		$result = ($domain && !$result)?'<b>ERROR:</b> connection could not be established with '.htmlspecialchars($domain):$result;
		return $result;
	}	
	
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_exm_sv/pi1/class.user_exmsv_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_exm_sv/pi1/class.user_exmsv_pi1.php']);
}

?>