<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Link example' for the 'user_linkexample' extension.
 *
 * @author  Ren Fritz <r.fritz@colorcube.de>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

require_once(t3lib_extMgm::extPath('cc_feinfo').'class.tx_ccfeinfo.php');

class user_linkexample_pi1 extends tslib_pibase {
	var $prefixId = 'user_linkexample_pi1';
	var $scriptRelPath = 'pi1/class.user_linkexample_pi1.php';
	var $extKey = 'user_linkexample';

	/**
	 * Plugin rendering function
	 */
	function main($content,$conf)   {
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();


			// If set caching is disabled
		$this->pi_USER_INT_obj=0;

			// enable auto caching
		$this->pi_autoCacheEn = 1;
			// register parameter for auto caching
		$this->pi_autoCacheFields = array(
				'opt1' => array('list' => array(0,1)),
				'opt2' => array('list' => array(0,1)),
			);

		$params = array('opt1','opt2','opt3');

			// build options form
		foreach ($params as $opt) {
			$options.= '<input type="checkbox" name="'.$this->prefixId.'['.$opt.']" value="1" '.($this->piVars[$opt]?'checked="checked"':'').'> '.$opt.'<br />';
		}

		$content = '
			<h3>Options:</h3>
			<form action="'.htmlspecialchars($this->pi_getPageLink($GLOBALS['TSFE']->id)).'" method="post">
				'.$options.'
				<input type="hidden" name="no_cache" value="1">
				<input type="submit" name="'.$this->prefixId.'_submit_button" value="Submit">
			</form>
			<br />
		';

			// show the current time - will not change with cached pages
		$content.= 'Rendering time: '.date('H:m:s',time()).'<br />';
		$content.= '<br />';

			// link with current piVars set by options form
		$content.= $this->pi_linkTP_keepPIvars('Link with Parameter').'<br />';

			// overrule opt3=1 which will force no_cache=1 (see pi_autoCacheFields)
		$overrule = array('opt3' => 1);
		$content.= $this->pi_linkTP_keepPIvars('Link with Parameter opt3=1', $overrule).'<br />';

			// insert feinfo
		$info = t3lib_div::makeInstance('tx_ccfeinfo');
		$info->init($this);
		$content.= $info->pi_getInfoOutput();

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_linkexample/pi1/class.user_linkexample_pi1.php'])    {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_linkexample/pi1/class.user_linkexample_pi1.php']);
}

?>