<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module extension (addition to function menu) 'Set index flag (recursive)' for the 'user_setsearch' extension.
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */

require_once (PATH_t3lib.'class.t3lib_pagetree.php');
require_once(PATH_t3lib.'class.t3lib_extobjbase.php');




/**
 * Creates the "set searchable" wizard
 * 
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */
class user_setsearch_modfunc1 extends t3lib_extobjbase {
	
	/**
	 * Page tree object
	 * @see t3lib_pageTree
	 */		
	var $tree;
	

	/**
	 * The current script (index.php)
	 */		
	var $thisScript;
	
		
	/**
	 * Adds menu items: Levels menu
	 * 
	 * @return	array		
	 * @ignore
	 */	
	function modMenu()	{
		global $LANG;
				
		$levelsLabel = $LANG->sL('LLL:EXT:lang/locallang_mod_web_perm.php:levels');
		return array(
			'user_setsearch_modfunc1_depth' => array(
				1 => '1 '.$levelsLabel,
				2 => '2 '.$levelsLabel,
				3 => '3 '.$levelsLabel,
				4 => '4 '.$levelsLabel,
				10 => '10 '.$levelsLabel
			)
		);
	}
	
	/**
	 * Main function creating the content for the module.
	 * 
	 * @return	string		HTML content for the module, actually a "section" made through the parent object in $this->pObj
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH;
		
		$this->thisScript = basename(PATH_thisScript);
		
		$this->getPageTree();

			// title
		$theOutput .= $this->pObj->doc->spacer(5);
		$theOutput .= $this->pObj->doc->section($LANG->getLL('title'),'',0,1);
		
			// depth menu
		$menu=$LANG->sL('LLL:EXT:lang/locallang_mod_web_perm.php:Depth').': '.
			t3lib_BEfunc::getFuncMenu($this->pObj->id,
				'SET[user_setsearch_modfunc1_depth]',
				$this->pObj->MOD_SETTINGS['user_setsearch_modfunc1_depth'],
				$this->pObj->MOD_MENU['user_setsearch_modfunc1_depth']
			);
			
		$theOutput .= $this->pObj->doc->spacer(5);
		$theOutput .= $this->pObj->doc->section('',$menu,0,1);
		
			// output page tree
		$theOutput .= $this->pObj->doc->spacer(10);
		$theOutput .= $this->pObj->doc->section('',$this->showPageTree(),0,1);
		
			// new form (close old)
		$theOutput .= '</form>';
		$theOutput .= $this->pObj->doc->spacer(10);
		
			// call tce_db.php script with the commands
		$theOutput .= '<form action="'.$BACK_PATH.'tce_db.php" method="POST" name="editform">';
		$theOutput .= '<input type="hidden" name="id" value="'.$this->pObj->id.'">';
		$theOutput .= '<input type="hidden" name="redirect" value="'.TYPO3_MOD_PATH.$this->thisScript.'?id='.$this->pObj->id.'">';
		$theOutput .= '<input type="hidden" name="data[pages]['.$this->pObj->id.'][no_search]" value="1">';
		$theOutput .= '<input type="hidden" name="mirror[pages]['.$this->pObj->id.']" value="'.htmlspecialchars(implode(',',$this->getEditablePagesIDArray())).'">';

			// submit buttons
		$theOutput .= '<input type="submit" name="setSearchable" value="'.$LANG->getLL('setSearchable').'" onclick="document.editform[\'data[pages]['.$this->pObj->id.'][no_search]\'].value=0;"> ';
		$theOutput .= '<input type="submit" name="setNonSearchable" value="'.$LANG->getLL('setNonSearchable').'">';

		
		return $theOutput;
	}
	
	
	/**
	 * Creates the page tree table
	 * 
	 * @return	string 	rendered HTML table
	 */	
	function showPageTree()	{
		global $BE_USER,$LANG,$BACK_PATH;

			// init table layout
		$tableLayout = array (
			'table' => array ('<table border="0" cellspacing="0" cellpadding="0" id="typo3-tree" style="width:auto;">', '</table>'),
			'0' => array (
				'tr' => array('<tr class="bgColor2">','</tr>'),
			),
			'defRow' => array (
				'tr' => array('<tr class="bgColor-20">','</tr>'),
				'0' => array('<td nowrap="nowrap">','</td>'),
				'1' => array('<td align="center" style="border-left: solid 1px '.$this->pObj->doc->bgColor.'">','</td>'),
			)
		);

		$table=array();
		$tr=0;
		
			// add header row
		$table[$tr][0] ='&nbsp;';
		$table[$tr++][1]='&nbsp;<img src="'.$BACK_PATH.t3lib_iconWorks::getIcon('tt_content_search',$this->pObj->pageinfo).'" width="18" height="16">&nbsp;';

			// walk through the tree list
		foreach($this->tree->tree as $pageItem)	{
			
				// if user has no access use a darker row background
			if (!($this->admin || $BE_USER->doesUserHaveAccess($pageItem['row'],2)))	{
				$tableLayout[$tr]['tr'] = array('<tr class="bgColor4">','</tr>');
			}
			
				// get one page tree item
			$title = t3lib_div::fixed_lgd($this->tree->getTitleStr($pageItem['row']),$BE_USER->uc['titleLen']);
			$treeItem = $pageItem['HTML'].$this->tree->wrapTitle($title,$pageItem['row']);
			
				// get current no_search flag
			if ($pageItem['row']['no_search']) {
				$searchFlag = '<span style="color:red">&times;</span>';
			} else {
				$searchFlag = '<span style="color:green">&bull;</span>';
			}
				// add row to table
 			$table[$tr][0] = $treeItem.'&nbsp;&nbsp;';
			$table[$tr++][1] = $searchFlag;
		}	
			// return rendered table
		return $this->pObj->doc->table($table, $tableLayout);
	}	


	/**
	 * Reads the page tree
	 * 
	 * @return	void
	 */
	function getPageTree()	{
		global $BE_USER,$LANG,$BACK_PATH;
		
		$this->tree = t3lib_div::makeInstance('user_setsearch_pageTree');
		$this->tree->init(' AND '.$this->pObj->perms_clause);
		$this->tree->setRecs = 1;
		$this->tree->makeHTML = true;
		$this->tree->thisScript = $this->thisScript;
		$this->tree->addField('no_search');
		$this->tree->addField('perms_userid',1);
		$this->tree->addField('perms_groupid',1);
		$this->tree->addField('perms_user',1);
		$this->tree->addField('perms_group',1);
		$this->tree->addField('perms_everybody',1);
		
			// Creating top icon; the current page
		$HTML = t3lib_iconWorks::getIconImage('pages',$this->pObj->pageinfo,$BACK_PATH,'align="top"');
		$this->tree->tree[] = array('row'=>$this->pObj->pageinfo,'HTML'=>$HTML);
		
			// read the page data and create the tree
		$this->tree->getTree($this->pObj->id, $this->pObj->MOD_SETTINGS['user_setsearch_modfunc1_depth']);
	}
	
	
	/**
	 * Returns an array of page id's where the user have access to
	 * 
	 * @return	array	pages uid array
	 */	
	function getEditablePagesIDArray()	{
		global $BE_USER,$LANG,$BACK_PATH;

		$idListArr=array();

		foreach ($this->tree->tree as $pageItem) {
			if ($this->admin || $BE_USER->doesUserHaveAccess($pageItem['row'],2))	{
				$idListArr[]=$pageItem['row']['uid'];
			}
		}

		return $idListArr;
	}
}


/**
 * local version of the page tree which points the title link to the current script
 * 
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */
class user_setsearch_pageTree extends t3lib_pageTree {
	function wrapTitle($title,$v)	{
		$aOnClick = 'return jumpToUrl(\''.$this->thisScript.'?id='.$v['uid'].'\',this);';
		return '<a href="#" onclick="'.htmlspecialchars($aOnClick).'">'.$title.'</a>';
	}
}


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/user_setsearch/modfunc1/class.user_setsearch_modfunc1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/user_setsearch/modfunc1/class.user_setsearch_modfunc1.php"]);
}

?>
