<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Addition of an item to the clickmenu
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */


class user_setsearchcm_cm1 {

	/**
	 * Adding options to the context menu.
	 *
	 * @param	object		The click menu object
	 * @param	array		Menu items array
	 * @param	string		Name of the table of the clicked record item
	 * @param	integer		uid of the record
	 * @return	array		Menu items array, processed.
	 */
	function main(&$cmObj, $menuItems, $table, $uid)	{
		global $LANG;

		if (!$cmObj->cmLevel) {
			if ($cmObj->editOK)	{

					// Returns directly, because the clicked item was not from the pages table
				if ($table != 'pages')	return $menuItems;

					// load the language array
				$LL = $this->includeLL();

					// array for new menu items
				$localItems = array();

						// create new menu item if not disabled
				if (!in_array('user_setsearchcm_cm1',$cmObj->disabledItems)) {

					$flagField = 'no_search';
					$title = ($cmObj->rec[$flagField]) ? $LANG->getLLL('searchable',$LL) : $LANG->getLLL('non_searchable',$LL);

					$localItems['user_setsearchcm_cm1'] = $cmObj->DB_changeFlag(
						'pages',
						$cmObj->rec,
						$flagField,
						$title,
						'no_search',
						t3lib_extMgm::extRelPath('user_setsearchcm')
					);
						// add menu item
					$menuItems = $cmObj->addMenuItems($menuItems, $localItems, 'after:hide,before-spacer:delete');
				}
			}
		}
		return $menuItems;
	}


	/**
	 * Includes the [extDir]/locallang.php and returns the $LOCAL_LANG array found in that file.
	 *
	 * @return	array		$LOCAL_LANG array
	 */
	function includeLL()	{
		include(t3lib_extMgm::extPath('user_setsearchcm').'locallang.php');
		return $LOCAL_LANG;
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_setsearchcm/class.user_setsearchcm_cm1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_setsearchcm/class.user_setsearchcm_cm1.php']);
}

?>