<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003 Ren Fritz (r.fritz@colorcube.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Visitor Counter' for the 'user_visitcounter' extension.
 *
 * @author	Ren Fritz <r.fritz@colorcube.de>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class user_visitcounter_pi1 extends tslib_pibase {
	var $prefixId = 'user_visitcounter_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.user_visitcounter_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'user_visitcounter';	// The extension key.

	/**
	 * Main plugin function
	 */
	function main($content,$conf)	{
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

		$table = 'user_visitcounter';

			// any page id configured?
		$pid = intval($this->cObj->stdWrap($conf['pid'],$conf['pid.']));
			// if not, use current page
		$pid = $pid ? $pid : $GLOBALS['TSFE']->id;


			// search for counter record
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $table, 'pid='.$pid, '', '', 1);
		if ($res) {
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
		} else {
				// initialize a new counter
			$row = array();
			$row['counter'] = 0;
		}

			// check if this user should be counted
		$knownUser = $GLOBALS['TSFE']->fe_user->getKey('ses',$this->extKey);
		if (!$knownUser) {
			$GLOBALS['TSFE']->fe_user->setKey('ses',$this->extKey,1);
			$GLOBALS['TSFE']->fe_user->storeSessionData();

			$row['counter'] += 1;
		}

			// update the counter record
		if ($row['uid']) {
			$this->cObj->DBgetUpdate($table, $row['uid'], $row, 'counter', true);
		} else {
			$this->cObj->DBgetInsert($table, $pid, $row, 'counter', true);
		}
		echo mysql_error();

			// render the counter with the TypoScript renderObj
		$lCObj = t3lib_div::makeInstance('tslib_cObj');
		$lCObj->setParent($this->cObj->data, $this->cObj->currentRecord);
		$lCObj->start($row, $table);
		$content = $lCObj->cObjGetSingle($conf['renderObj'], $conf['renderObj.']);

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_visitcounter/pi1/class.user_visitcounter_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/user_visitcounter/pi1/class.user_visitcounter_pi1.php']);
}

?>